/*-
 * ~~~~~~licensing~~~~~~
 * core-support-runtime
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.support.runtime.cxf;

import org.apache.cxf.Bus;
import org.apache.cxf.common.util.ClassUnwrapper;
import org.osgi.framework.BundleContext;

public abstract class EntaxyCxfClassUnwrapper implements ClassUnwrapper {

	protected Bus bus;
	
	protected BundleContext bundleContext;
	
	public void activate() {
	}
	
	@Override
	public Class<?> getRealClass(Object o) {
		if (o == null)
			return null;
		if (o instanceof EntaxyCxfServiceClassProxy) 
			return doGetRealClassFromClassName(((EntaxyCxfServiceClassProxy)o).getRealClassName());
		if (o instanceof EntaxyCxfServiceBeanProxy) {
			return getRealClassFromClass(EntaxyCxfServiceBeanProxy.class);
		} else {
			return EntaxyCxfClassHelper.getDefaultClassUnwrapper(bus).getRealClass(o);
		}
	}
	
	@Override
	public Class<?> getRealClassFromClass(Class<?> clazz) {
		if (checkClass(clazz)) {
			return doGetRealClassFromClass(clazz);
		}
		return EntaxyCxfClassHelper.getDefaultClassUnwrapper(bus).getRealClassFromClass(clazz);
	}

	protected abstract Class<?> doGetRealClassFromClassName(String className);
	
	protected abstract Class<?> doGetRealClassFromClass(Class<?> clazz);
	
	protected boolean checkObject(Object o) {
		return o instanceof EntaxyCxfServiceBeanProxy;
	}

	protected boolean checkClass(Class<?> clazz) {
		return EntaxyCxfServiceBeanProxy.class.isAssignableFrom(clazz);
	}

	public Bus getBus() {
		return bus;
	}

	public void setBus(Bus bus) {
		this.bus = bus;
	}

	public BundleContext getBundleContext() {
		return bundleContext;
	}

	public void setBundleContext(BundleContext bundleContext) {
		this.bundleContext = bundleContext;
	}
	
}
